/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * {@link MgCoordinateSystemGridSpecification} is an object that is used to
 * convey all the parameters necessary for the generation of a grid/graticule
 * lumped into a single object for convenience.  Thus, adding a parameter
 * determined to be necessary at a later time does not alter a lot of calling
 * sequences.
 * Note that this interface is an abstract interface.  There is code
 * associated with the implementation of this interface which is used to
 * handle the conversion of parameters between the various unit systems.
 * Thus, one obtains a {@link MgCoordinateSystemGridSpecification} from the
 * {@link MgCoordinateSystemFactory} object.
 * Note that all values are provided in the units specified within the object.
 * The units used in this object do <b>not</b> need to be the same as any
 * coordinate system involved in the generation of a grid, although the
 * <b>type</b> of unit must be consistent with the type of grid being drawn.
 * That is, specifying a Angular unit type when drawing a UTM grid will cause
 * an exception at the time the request for (say) grid lines is issued.
 *
 * @since  2.2 */
 public class MgCoordinateSystemGridLineCollection extends MgGuardDisposable {
  private long swigCPtr;

  public MgCoordinateSystemGridLineCollection(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgCoordinateSystemGridLineCollectionToMgGuardDisposable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected MgCoordinateSystemGridLineCollection() {
    this(0, false);
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgCoordinateSystemGridLineCollection(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgCoordinateSystemGridLineCollection obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Gets the number of grid lines in this collection
 *
 * @return  The number of grid lines in this collection
 */
 public int getCount() {
    return MapGuideDesktopApiJNI.MgCoordinateSystemGridLineCollection_GetCount(swigCPtr);
  }

  
/**
 * Gets the grid line at the specified index
 *
 * @param  index (int)  The index
 * @return  The grid line ({@link MgCoordinateSystemGridLine}) at the specified index
 */
 public MgCoordinateSystemGridLine getItem(int index) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemGridLineCollection_GetItem(swigCPtr, index);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridLine)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Gets the index of the given grid orientation and value
 *
 * @param  gridOrientation (int)  The grid orientation
 * @param  gridValue (double)  The grid value
 * @return  The index of the given grid orientation and value
 */
 public int indexOf(int gridOrientation, double gridValue) {
    return MapGuideDesktopApiJNI.MgCoordinateSystemGridLineCollection_IndexOf(swigCPtr, gridOrientation, gridValue);
  }

  
/**
 * Removes the grid line at the specified index
 *
 * @param  index (int)  The index to remove
 */
 public void removeAt(int index) {
    MapGuideDesktopApiJNI.MgCoordinateSystemGridLineCollection_RemoveAt(swigCPtr, index);
  }

  
/**
 * Removes all grid lines from this collection
 *
 */
 public void clear() {
    MapGuideDesktopApiJNI.MgCoordinateSystemGridLineCollection_Clear(swigCPtr);
  }

}
