/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * {@link MgDateTime} is used to store dates, times, or both.
 *
 * @param  year  Year in the range of 1 to 9999
 * @param  month  Month in the range of 1 to 12 inclusive (January = 1)
 * @param  day  Day of the month in the range of 1 to 31 inclusive
 * @param  hour  Hour since midnight in the range of 0 to 23
 * @param  minute  Minutes after hour in the range of 0 to 59
 * @param  second  Seconds after minute in the range of 0 to 59
 * @param  microsecond  Microseconds after second in the range of 0 to 999999
 */
 public class MgDateTime extends MgSerializable {
  private long swigCPtr;

  public MgDateTime(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgDateTimeToMgSerializable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgDateTime(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgDateTime obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Construct a date time value initialized to the
 * current date and time
 *
 * @return  Returns nothing.
 */
 public MgDateTime() {
    this(MapGuideDesktopApiJNI.new_MgDateTime__SWIG_0(), true);
  }

  
/**
 * Construct a date value
 *
 * @param  year (short/int)  Input year
 * @param  month (short/int)  Input month
 * @param  day (short/int)  Input day of month
 * @return  Returns nothing.
 */
 public MgDateTime(short year, short month, short day) {
    this(MapGuideDesktopApiJNI.new_MgDateTime__SWIG_1(year, month, day), true);
  }

  
/**
 * Construct a time value
 *
 * @param  hour (short/int)  Input hour
 * @param  minute (short/int)  Input minute
 * @param  second (short/int)  Input second
 * @param  microsecond (int)  Input microsecond
 * @return  Returns nothing.
 */
 public MgDateTime(short hour, short minute, short second, int microsecond) {
    this(MapGuideDesktopApiJNI.new_MgDateTime__SWIG_2(hour, minute, second, microsecond), true);
  }

  
/**
 * Construct a date time value
 *
 * @param  year (short/int)  Input year
 * @param  month (short/int)  Input month
 * @param  day (short/int)  Input day of month
 * @param  hour (short/int)  Input hour
 * @param  minute (short/int)  Input minute
 * @param  second (short/int)  Input second
 * @param  microsecond (int)  Input microsecond
 * @return  Returns nothing.
 */
 public MgDateTime(short year, short month, short day, short hour, short minute, short second, int microsecond) {
    this(MapGuideDesktopApiJNI.new_MgDateTime__SWIG_3(year, month, day, hour, minute, second, microsecond), true);
  }

  
/**
 * Gets the day component of this object
 *
 * @return  Returns the day component of this object.
 */
 public short getDay() {
    return MapGuideDesktopApiJNI.MgDateTime_GetDay(swigCPtr);
  }

  
/**
 * Gets the month component of this object
 *
 * @return  Returns the month component of this object.
 */
 public short getMonth() {
    return MapGuideDesktopApiJNI.MgDateTime_GetMonth(swigCPtr);
  }

  
/**
 * Gets the year component of this object
 *
 * @return  Returns the year component of this object.
 */
 public short getYear() {
    return MapGuideDesktopApiJNI.MgDateTime_GetYear(swigCPtr);
  }

  
/**
 * Gets the hour component of this object
 *
 * @return  Returns the hour component of this object.
 */
 public short getHour() {
    return MapGuideDesktopApiJNI.MgDateTime_GetHour(swigCPtr);
  }

  
/**
 * Gets the minute component of this object
 *
 * @return  Returns the minute component of this object.
 */
 public short getMinute() {
    return MapGuideDesktopApiJNI.MgDateTime_GetMinute(swigCPtr);
  }

  
/**
 * Gets the second component of this object
 *
 * @return  Returns the second component of this object.
 */
 public short getSecond() {
    return MapGuideDesktopApiJNI.MgDateTime_GetSecond(swigCPtr);
  }

  
/**
 * Gets the microsecond component of this object
 *
 * @return  Returns the microsecond component of this object.
 */
 public int getMicrosecond() {
    return MapGuideDesktopApiJNI.MgDateTime_GetMicrosecond(swigCPtr);
  }

  
/**
 * Sets the day component of this object
 * The Validate method should be called after the date time value has been
 * fully specified by Set methods.
 *
 * @param  day (short/int)  Day of the month in the range of 1 to 31 inclusive
 */
 public void setDay(short day) {
    MapGuideDesktopApiJNI.MgDateTime_SetDay(swigCPtr, day);
  }

  
/**
 * Sets the month component of this object
 * The Validate method should be called after the date time value has been
 * fully specified by Set methods.
 *
 * @param  month (short/int)  Month in the range of 1 to 12 inclusive (January = 1)
 */
 public void setMonth(short month) {
    MapGuideDesktopApiJNI.MgDateTime_SetMonth(swigCPtr, month);
  }

  
/**
 * Sets the year component of this object
 * The Validate method should be called after the date time value has been
 * fully specified by Set methods.
 *
 * @param  year (short/int)  Year in the range of 1 to 9999
 */
 public void setYear(short year) {
    MapGuideDesktopApiJNI.MgDateTime_SetYear(swigCPtr, year);
  }

  
/**
 * Sets the hour component of this object
 * The Validate method should be called after the date time value has been
 * fully specified by Set methods.
 *
 * @param  hour (short/int)  Hour since midnight in the range of 0 to 23
 */
 public void setHour(short hour) {
    MapGuideDesktopApiJNI.MgDateTime_SetHour(swigCPtr, hour);
  }

  
/**
 * Sets the minute component of this object
 * The Validate method should be called after the date time value has been
 * fully specified by Set methods.
 *
 * @param  minute (short/int)  Minutes after hour in the range of 0 to 59
 */
 public void setMinute(short minute) {
    MapGuideDesktopApiJNI.MgDateTime_SetMinute(swigCPtr, minute);
  }

  
/**
 * Sets the second component of this object
 * The Validate method should be called after the date time value has been
 * fully specified by Set methods.
 *
 * @param  second (short/int)  Seconds after minute in the range of 0 to 59
 */
 public void setSecond(short second) {
    MapGuideDesktopApiJNI.MgDateTime_SetSecond(swigCPtr, second);
  }

  
/**
 * Sets the microsecond component of this object
 * The Validate method should be called after the date time value has been
 * fully specified by Set methods.
 *
 * @param  microsecond (int)  Microseconds after second in the range of 0 to 999999
 */
 public void setMicrosecond(int microsecond) {
    MapGuideDesktopApiJNI.MgDateTime_SetMicrosecond(swigCPtr, microsecond);
  }

  
/**
 * Validates the date time value.  This method should be called
 * after the date time value has been fully specified by Set methods.
 *
 * @return  Returns nothing.
 */
 public void validate() {
    MapGuideDesktopApiJNI.MgDateTime_Validate(swigCPtr);
  }

  
/**
 * Determines if this object only represents a date value.
 *
 * @return  Returns true if only the date is valid; otherwise returns false.
 */
 public boolean isDate() {
    return MapGuideDesktopApiJNI.MgDateTime_IsDate(swigCPtr);
  }

  
/**
 * Determines if this object only represents a time value.
 *
 * @return  Returns true if only the time is valid; otherwise returns false.
 */
 public boolean isTime() {
    return MapGuideDesktopApiJNI.MgDateTime_IsTime(swigCPtr);
  }

  
/**
 * Determines if this object represents both date and time values.
 *
 * @return  Returns true if both the date and time are valid; otherwise returns false.
 */
 public boolean isDateTime() {
    return MapGuideDesktopApiJNI.MgDateTime_IsDateTime(swigCPtr);
  }

  
/**
 * Returns date time object as a string
 *
 */
 public String toString() {
  { return MapGuideDesktopApiJNI.MgDateTime_ToString(swigCPtr); }
}

}
